#pragma once
#ifndef SERVER_COMMON_ROUND_TRIP_TIME_INCLUDED__
#define SERVER_COMMON_ROUND_TRIP_TIME_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: RoundTripTime.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2010 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/CoreTools/Types.h"

///////////////////////////////////////////////////////////////////////////////
// CRoundTripTime
///////////////////////////////////////////////////////////////////////////////

class CRoundTripTime
{
   public :

      enum Status
      {
         Unsent      = 0x00,
         Sent        = 0x01,
         Received    = 0x11
      };

      CRoundTripTime();

      void MarkAsSent();

      void MarkAsReceived();

      Status GetStatus() const;

      DWORD GetSentTime() const;

      DWORD GetReceivedTime() const;

      DWORD GetRoundTripTime() const;

   private :

      DWORD m_sentTime;
      DWORD m_recvTime;

      Status m_status;
};

#endif // SERVER_COMMON_ROUND_TRIP_TIME_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: RoundTripTime.h
///////////////////////////////////////////////////////////////////////////////
