@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined NUM_CONNECTIONS set NUM_CONNECTIONS=50
if not defined NUM_MESSAGES set NUM_MESSAGES=1000

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug

if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug

Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo Optional: SUPPORTS_OLD_TESTS=%SUPPORTS_OLD_TESTS%
Echo Optional: NUM_CONNECTIONS=%NUM_CONNECTIONS%
Echo Optional: NUM_MESSAGES=%NUM_MESSAGES%
Echo -

:NoDebug

:RunTests

setlocal

set TEST_NAME=%BASE_TEST_NAME% EchoServerTest.exe
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\EchoServerTest.exe"
set TEST_CLIENT_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageSize 1000 -messageRate 0 -sendAfterRecv -skipSignOnBytes 24 -readTimeout 10000 -messageFlowTimeout 60000

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

Echo *********************************
Echo * Running the service as an exe *
Echo *********************************

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

REM Now install and run as a service if we can

Echo ***********************************
Echo * Running the service via the SCM *
Echo ***********************************

call ..\..\Test\RunAsServiceTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

if not defined SUPPORTS_OLD_TESTS goto Done

set CLIENT_TEST_RUNNER=

set TEST_NAME=%BASE_TEST_NAME% SocketServerTest.exe
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\SocketServerTest.exe"
set TEST_CLIENT_ARGS=EchoServerTest.xml

Echo *********************************
Echo * Running the service as an exe *
Echo *********************************

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

Echo ***********************************
Echo * Running the service via the SCM *
Echo ***********************************

call ..\..\Test\RunAsServiceTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

:Done
